HDU 1240 Asteroids! 广度优先搜索

Asteroids!Time Limit: 2000/1000 MS (Java/Others)Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4038Accepted Submission(s): 2605

Problem Description

You’re in space.You want to get home.There are asteroids.You don’t want to hit them.

Input

Input to this problem will consist of a (non-empty) series of up to 100 data sets. Each data set will be formatted according to the following description, and there will be no blank lines separating data sets.A single data set has 5 components:Start line – A single line, "START N", where 1 <= N <= 10.Slice list – A series of N slices. Each slice is an N x N matrix representing a horizontal slice through the asteroid field. Each position in the matrix will be one of two values:’O’ – (the letter "oh") Empty space’X’ – (upper-case) Asteroid presentStarting Position – A single line, "A B C", denoting the <A,B,C> coordinates of your craft’s starting position. The coordinate values will be integers separated by individual spaces.Target Position – A single line, "D E F", denoting the <D,E,F> coordinates of your target’s position. The coordinate values will be integers separated by individual spaces.End line – A single line, "END"The origin of the coordinate system is <0,0,0>. Therefore, each component of each coordinate vector will be an integer between 0 and N-1, inclusive.The first coordinate in a set indicates the column. Left column = 0.The second coordinate in a set indicates the row. Top row = 0.The third coordinate in a set indicates the slice. First slice = 0.Both the Starting Position and the Target Position will be in empty space.

Output

For each data set, there will be exactly one output set, and there will be no blank lines separating output sets.A single output set consists of a single line. If a route exists, the line will be in the format "X Y", where X is the same as N from the corresponding input data set and Y is the least number of moves necessary to get your ship from the starting position to the target position. If there is no route from the starting position to the target position, the line will be "NO ROUTE" instead.A move can only be in one of the six basic directions: up, down, left, right, forward, back. Phrased more precisely, a move will either increment or decrement a single component of your current position vector by 1.

Sample Input

START 1O0 0 00 0 0ENDSTART 3XXXXXXXXXOOOOOOOOOXXXXXXXXX0 0 12 2 1ENDSTART 5OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOXXXXXXXXXXXXXXXXXXXXXXXXXOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO0 0 04 4 4END

Sample Output

1 03 4NO ROUTE

三维的搜索,和胜利大逃亡差不多。他的题意求出从起点到终点最短路径,X是不能通过的,,O是可以通过。但是如果终点是X的话,是可以到达的,所以搜索钱要把终点标记为O。

#include<iostream>#include<cstdio>#include<cstring>#include<queue>using namespace std;#define N 20char map[N][N][N];int vis[N][N][N];int dx[] = { 0, 0, -1, 1, 0, 0 };int dy[] = { 0, 0, 0, 0, -1, 1 };int dz[] = { -1, 1, 0, 0, 0, 0 };char s[10];int n, sx, sy, sz, ex, ey, ez;struct point{int x, y, z, step;};int bfs(){if (sx == ex && sy == ey && sz == ez)return 0;point temp, head, tt;queue<point>q;vis[sx][sy][sz] = 1;temp.x = sx;temp.y = sy;temp.z = sz;temp.step = 0;q.push(temp);while (!q.empty()){head = q.front();q.pop();if (head.x == ex&&head.y == ey&&head.z == ez)return head.step;for (int i = 0; i < 6; i++){tt.x = head.x + dx[i];tt.y = head.y + dy[i];tt.z = head.z + dz[i];if (!(tt.x < 0 || tt.y < 0 || tt.z < 0 || tt.x >= n || tt.y >= n || tt.z >= n || vis[tt.x][tt.y][tt.z]||map[tt.x][tt.y][tt.z]=='X')){tt.step = head.step + 1;vis[tt.x][tt.y][tt.z] = 1;q.push(tt);}}}return (-1);}int main(){while (~scanf("%s%d", s, &n)){memset(vis, 0, sizeof(vis));for (int i = 0; i<n; i++){for (int j = 0; j<n; j++){scanf("%s", map[i][j]);}}scanf("%d%d%d%d%d%d", &sx, &sy, &sz, &ex, &ey, &ez);scanf("%s", s);map[ex][ey][ez] = 'O';int ans = bfs();if (ans >= 0){printf("%d %d\n", n, ans);}else{printf("NO ROUTE\n");}}return 0;}

也就越容易失败,还不如怀揣一颗平常心,“但行好事,莫问前程”,往往成功的几率反而更大些

HDU 1240 Asteroids! 广度优先搜索

相关文章:

你感兴趣的文章:

标签云: